/**
 * this Class represents the GUI for Insomnia
 * @zahra_Fatehi
 * @version 0.0
 */

import javax.imageio.ImageIO;
import javax.swing.*;
import javax.swing.border.Border;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import static com.sun.glass.ui.Cursor.setVisible;
import static java.awt.Frame.*;


public class InsomniaGUI {
    JFrame frame ;
    public InsomniaGUI() throws IOException {
        frame = new JFrame();
        frame.setTitle("Insomnia");
        frame.setSize(900,600);
        frame.setLocation(200,100);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);


        BufferedImage master;
        master = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\Insomnia\\src\\image\\535246.png"));
        Image scaled = master.getScaledInstance(20,20, java.awt.Image.SCALE_SMOOTH);
        VerticalFlowLayout vfLayout = new VerticalFlowLayout();
        Border border = BorderFactory.createLineBorder(Color.BLACK,3);


        JPanel body = new JPanel();
        body.setBackground(Color.GRAY);
        JPanel auth = new JPanel();
        auth.setBackground(Color.GRAY);
        JPanel query = new JPanel();
        query.setBackground(Color.GRAY);
        JPanel mainCenterHeader = new JPanel(vfLayout);
        mainCenterHeader.setBackground(Color.GRAY);
        JScrollPane scrollPane_Header_Request = new JScrollPane(mainCenterHeader);
        scrollPane_Header_Request.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        JPanel docs = new JPanel();
        docs.setBackground(Color.GRAY);


        //request-center
        JTabbedPane tabbedPaneCenterRequest = new JTabbedPane();
        tabbedPaneCenterRequest.setBackground(Color.GRAY);
        tabbedPaneCenterRequest.add("Body" , body);
        tabbedPaneCenterRequest.add("Auth" , auth);
        tabbedPaneCenterRequest.add("Query" , query);
        tabbedPaneCenterRequest.add("Header" , scrollPane_Header_Request);
        tabbedPaneCenterRequest.add("Docs" , docs);
        JTextField headerField = new JTextField("header");
        headerField.addMouseListener(new MouseListener() {
            @Override
            public void mouseClicked(MouseEvent e) {
                JTextField newHeaderField = new JTextField("header");
                newHeaderField.setBorder(border);
                JTextField newValueField = new JTextField("value");
                newValueField.setBorder(border);
                JCheckBox newCheckBox = new JCheckBox();
                JButton newDelete = new JButton();
                newDelete.setPreferredSize(new Dimension(20,20));
                newDelete.setIcon(new ImageIcon(scaled));
                JPanel newRightOfHeader = new JPanel();
                newRightOfHeader.add(newCheckBox);
                newRightOfHeader.add(newDelete);
                JPanel new_center_header = new JPanel(new GridLayout(1, 2));
                new_center_header.add(newHeaderField);
                new_center_header.add(newValueField);
                JPanel newHeader = new JPanel(new BorderLayout());
                newHeader.add(newRightOfHeader, BorderLayout.EAST);
                newHeader.add(new_center_header, BorderLayout.CENTER);
                mainCenterHeader.add(newHeader );

            }

            @Override
            public void mousePressed(MouseEvent e) {

            }

            @Override
            public void mouseReleased(MouseEvent e) {

            }

            @Override
            public void mouseEntered(MouseEvent e) {

            }

            @Override
            public void mouseExited(MouseEvent e) {

            }
        });
        TextFieldHandler textFieldHandler = new TextFieldHandler(headerField,mainCenterHeader,border);//create a actionListener
        headerField.setFocusable(true);
        headerField.addActionListener( textFieldHandler);
        headerField.setBorder(border);
        JTextField valueField = new JTextField("value");
        valueField.setBorder(border);
        JCheckBox checkBox = new JCheckBox();
        JButton delete = new JButton();
        delete.setIcon(new ImageIcon(scaled));
        delete.setPreferredSize(new Dimension(20,20));
        JPanel rightOfHeader = new JPanel();
        rightOfHeader.add(checkBox);
        rightOfHeader.add(delete);
        JPanel center_header = new JPanel(new GridLayout(1,2));
        center_header.add(headerField);
        center_header.add(valueField);
        JPanel header = new JPanel(new BorderLayout());
        header.add(rightOfHeader,BorderLayout.EAST);
        header.add(center_header,BorderLayout.CENTER);
        mainCenterHeader.add(header);




        //request_up
        String s []={"Patch","Put","Post","Delete","Get"};
        JComboBox centerMenu = new JComboBox(s);
        centerMenu.setFont(new Font("Arial",20,15 ));

        JTextField URLTextField = new JTextField("http://api.myproduct.com/v1/users");

        JButton sendButton = new JButton("send");

        JPanel centerUp = new JPanel(new BorderLayout());
        centerUp.add(centerMenu , BorderLayout.WEST);
        centerUp.add(URLTextField , BorderLayout.CENTER);
        centerUp.add(sendButton , BorderLayout.EAST);

        JPanel request = new JPanel(new BorderLayout());
        request.add(centerUp,BorderLayout.NORTH);
        request.add(tabbedPaneCenterRequest , BorderLayout.CENTER);

        //respond
        JPanel row = new JPanel();
        JTextArea massageBody = new JTextArea();
        massageBody.setPreferredSize(new Dimension(200,300));
        row.add(massageBody);
        row.setBackground(Color.GRAY);
        JPanel mainCenterHeader_respond = new JPanel(vfLayout);
        JScrollPane scrollPane_Header_Request2 = new JScrollPane(mainCenterHeader_respond);
        scrollPane_Header_Request.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        mainCenterHeader_respond.setBackground(Color.GRAY);
        JPanel header_MainPanel = new JPanel(new BorderLayout());
        header_MainPanel.setBackground(Color.GRAY);
        JButton copyToClipBoard = new JButton("copy to clip board");
        header_MainPanel.add(scrollPane_Header_Request2 , BorderLayout.CENTER);
        header_MainPanel.add(copyToClipBoard,BorderLayout.SOUTH);
        JPanel cookie = new JPanel();
        cookie.setBackground(Color.GRAY);
        JPanel timeline = new JPanel(new BorderLayout());
        timeline.setBackground(Color.GRAY);
        JTabbedPane tabbedPaneCenterResponse = new JTabbedPane();
        tabbedPaneCenterResponse.setBackground(Color.GRAY);
        tabbedPaneCenterResponse.add("Row" , row);
        tabbedPaneCenterResponse.add("Header" , header_MainPanel);
        tabbedPaneCenterResponse.add("Cookie", cookie);
        tabbedPaneCenterResponse.add("Timeline" , timeline);
        JPanel response = new JPanel(new BorderLayout());
        JTextField headerField2 = new JTextField("header");
        headerField2.setEditable(false);
        headerField2.addMouseListener(new MouseListener() {
            @Override
            public void mouseClicked(MouseEvent e) {
                System.out.println(")))))))))))");
               // if (!headerField2.getText().equals("") ) {
                    JTextField newHeaderField = new JTextField("header");
                    newHeaderField.setEditable(false);
                    newHeaderField.setBorder(border);
                    JTextField newValueField = new JTextField("value");
                    newValueField.setEditable(false);
                    newValueField.setBorder(border);
                    JPanel new_center_header = new JPanel(new GridLayout(1, 2));
                    new_center_header.add(newHeaderField);
                    new_center_header.add(newValueField);
                    JPanel newHeader = new JPanel(new BorderLayout());
                    newHeader.add(new_center_header, BorderLayout.CENTER);
                    mainCenterHeader_respond.add(newHeader );
             //   }
            }

            @Override
            public void mousePressed(MouseEvent e) {

            }

            @Override
            public void mouseReleased(MouseEvent e) {

            }

            @Override
            public void mouseEntered(MouseEvent e) {

            }

            @Override
            public void mouseExited(MouseEvent e) {

            }
        });
        headerField2.setBorder(border);
        JTextField valueField2 = new JTextField("value");
        valueField2.setEditable(false);
        valueField2.setBorder(border);
        JPanel center_header2 = new JPanel(new GridLayout(1,2));
        center_header2.add(headerField2);
        center_header2.add(valueField2);
        JPanel header2 = new JPanel(new BorderLayout());
        header2.add(center_header2,BorderLayout.CENTER);
        mainCenterHeader_respond.add(header2);




        JPanel up_response = new JPanel();
        JLabel label1 = new JLabel("ok");
        label1.setBorder(border);
        JLabel label2 = new JLabel("s");
        label2.setBorder(border);
        JLabel label3 = new JLabel("KB");
        label3.setBorder(border);
        up_response.add(label1);
        up_response.add(label2);
        up_response.add(label3);

        response.add(tabbedPaneCenterResponse , BorderLayout.CENTER);
        response.add(up_response,BorderLayout.NORTH);


        JPanel panelRight = new JPanel(new GridLayout(1 ,2 ));
        panelRight.add(request);
        panelRight.add(response);


        JMenu menu = new JMenu("Insomnia");
        menu.setFont(new Font("Arial",20,15 ));
        menu.setBorder(border);
        menu.setPreferredSize(new Dimension(200,60));
        JButton addRequest = new JButton("Add Request");
        JPanel up_left = new JPanel(new GridLayout(2,1));
        up_left.add(menu);
        up_left.add(addRequest);
        up_left.setBackground(Color.GRAY);
        JPanel requestList = new JPanel(vfLayout);
        requestList.setBackground(Color.GRAY);
        JScrollPane scrollRequests = new JScrollPane(requestList);
        addRequest.addMouseListener(new MouseListener() {
            @Override
            public void mouseClicked(MouseEvent e) {
                int i = 1;
                JLabel jLabel= new JLabel("request"+i);
                requestList.add(jLabel);
                i++;
            }
            @Override
            public void mousePressed(MouseEvent e) {
            }

            @Override
            public void mouseReleased(MouseEvent e) {

            }

            @Override
            public void mouseEntered(MouseEvent e) {

            }

            @Override
            public void mouseExited(MouseEvent e) {

            }
        });


        //left panel (list of requests)
        JPanel panelLeft = new JPanel(new BorderLayout());
        panelLeft.setBackground(Color.GRAY);
        panelLeft.add(up_left , BorderLayout.NORTH);
        panelLeft.add(scrollRequests, BorderLayout.CENTER);
        panelLeft.setBackground(Color.LIGHT_GRAY);

        //menu upper_Items
        JMenuBar upperMenuBar = new JMenuBar();
        JMenu application = new JMenu("Application");
        JMenuItem OptionItem = new JMenuItem("Option");
        OptionItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O , ActionEvent.CTRL_MASK));
        JPanel optionPanel = new JPanel(new GridLayout(3,1));
        JCheckBox followRedirect = new JCheckBox("follow redirect");
        JCheckBox hideInSystemTray = new JCheckBox("hide in system tray");
        String color []={"light theme","dark theme"};
        JComboBox backGroundColor = new JComboBox(color);
        backGroundColor.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String s = (String) backGroundColor.getSelectedItem();//get the selected item

                switch (s) {//check for a match
                    case "light theme":{
                        body.setBackground(Color.WHITE);
                        auth.setBackground(Color.WHITE);
                        query.setBackground(Color.WHITE);
                        mainCenterHeader.setBackground(Color.WHITE);
                        docs.setBackground(Color.WHITE);
                        row.setBackground(Color.WHITE);
                        mainCenterHeader_respond.setBackground(Color.WHITE);
                        header.setBackground(Color.WHITE);
                        header2.setBackground(Color.WHITE);
                        header_MainPanel.setBackground(Color.WHITE);
                        timeline.setBackground(Color.WHITE);
                        cookie.setBackground(Color.WHITE);
                        panelRight.setBackground(Color.WHITE);
                        up_left.setBackground(Color.WHITE);
                        requestList.setBackground(Color.WHITE);
                        break;
                    }
                    case "dark theme":{
                        body.setBackground(Color.DARK_GRAY);
                        auth.setBackground(Color.DARK_GRAY);
                        query.setBackground(Color.DARK_GRAY);
                        mainCenterHeader.setBackground(Color.DARK_GRAY);
                        docs.setBackground(Color.DARK_GRAY);
                        row.setBackground(Color.DARK_GRAY);
                        mainCenterHeader_respond.setBackground(Color.DARK_GRAY);
                        header.setBackground(Color.DARK_GRAY);
                        header2.setBackground(Color.DARK_GRAY);
                        header_MainPanel.setBackground(Color.DARK_GRAY);
                        timeline.setBackground(Color.DARK_GRAY);
                        cookie.setBackground(Color.DARK_GRAY);
                        up_left.setBackground(Color.DARK_GRAY);
                        requestList.setBackground(Color.DARK_GRAY);
                    }
                }
            }
        });
        backGroundColor.setFont(new Font("Arial",20,15 ));
        optionPanel.add(followRedirect);
        optionPanel.add(hideInSystemTray);
        optionPanel.add(backGroundColor);
        JFrame optionFrame= new JFrame("option");
        optionFrame.setPreferredSize(new Dimension(100,100));
        optionPanel.setPreferredSize(new Dimension(100,100));
        optionFrame.add(optionPanel);
        OptionItem.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                optionFrame.setVisible(true);
            }
        });


        JMenuItem exitItem = new JMenuItem("Exit  ");
        exitItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T,ActionEvent.ALT_MASK));
        exitItem.addActionListener(new exitApp(hideInSystemTray));
        application.add(OptionItem);
        application.add(exitItem);
        JMenu edit = new JMenu("Edit");
        edit.setMnemonic('E');
        JMenu view = new JMenu("View");
        view.setMnemonic('V');
        JMenuItem ToggleFullScreen = new JMenuItem("Toggle Full Screen");
        ToggleFullScreen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T , KeyEvent.VK_F));
        ToggleFullScreen.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (frame.getExtendedState() == MAXIMIZED_BOTH){
                    frame.setExtendedState(NORMAL);
                }
                else {
                    frame.setExtendedState(MAXIMIZED_BOTH);
                }
            }
        });
        JMenuItem ToggleSidebar = new JMenuItem("Toggle Sidebar");
        ToggleSidebar.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (panelLeft.isVisible() == true) {
                    panelLeft.setVisible(false);
                }
                else {
                    panelLeft.setVisible(true);
                }
            }
        });
        ToggleSidebar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L ,KeyEvent.VK_S ));
        view.add(ToggleFullScreen);
        view.add(ToggleSidebar);
        JMenu window = new JMenu("Tools");
        window.setMnemonic('W');
        JMenuItem minimize = new JMenuItem("Minimize");
        window.add(minimize);
        JMenu help = new JMenu("Help");
        help.setMnemonic('H');
        JMenuItem  aboutItem = new JMenuItem("About");
        aboutItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A , ActionEvent.CTRL_MASK));
        aboutItem.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                JPanel aboutPanel = new JPanel();
                JTextArea aboutText = new JTextArea();
                aboutText.setEditable(false);
                aboutText.setText("developer\tzahra seyedFatehi    \nEmail   \ts.fatehi1378@Gmail.com\nstudent number\t9731301");
                aboutPanel.add(aboutText);
                aboutText.setPreferredSize(new Dimension(300,200));
                JFrame frame = new JFrame("About");
                frame.setLocation(100,100);
                frame.setPreferredSize(new Dimension(200,200));
                frame.add(aboutPanel);
                frame.setVisible(true);
            }
        });
        help.add( aboutItem);
        JMenuItem helpItem= new JMenuItem("help");
        helpItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H , ActionEvent.CTRL_MASK));
        helpItem.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                JPanel helpPanel = new JPanel();
                JTextArea helpText = new JTextArea();
                helpPanel.add(helpText);
                frame.setLocation(100,100);
                frame.setPreferredSize(new Dimension(200,200));
                frame.add(helpPanel);
                frame.setVisible(true);
            }
        });
        help.add(helpItem);
        upperMenuBar.add(application);
        upperMenuBar.add(edit);
        upperMenuBar.add(view);
        upperMenuBar.add(window);
        upperMenuBar.add(help);
        upperMenuBar.setFocusable(true);



        JPanel panel = new JPanel(new BorderLayout());
        panel.add(upperMenuBar , BorderLayout.NORTH);
        panel.add(panelLeft , BorderLayout.WEST);
        panel.add(panelRight , BorderLayout.CENTER);

        frame.getContentPane().add(panel);
    }

    private class TextFieldHandler implements ActionListener{
        JTextField headerField ;
        JPanel mainCenterHeader;
        Border border;
        private TextFieldHandler(JTextField headerField , JPanel mainCenterHeader , Border border){
            this.headerField = headerField;
            this.mainCenterHeader = mainCenterHeader;
            this.border = border;
        }
        @Override
        public void actionPerformed(ActionEvent e) {
            System.out.println("++++++++++++");
            if (!headerField.getText().equals("") ) {
                JTextField newHeaderField = new JTextField("header");
                newHeaderField.setBorder(border);
                JTextField newValueField = new JTextField("value");
                newValueField.setBorder(border);
                JCheckBox newCheckBox = new JCheckBox();
                JButton newDelete = new JButton(new ImageIcon("C:\\Users\\Lenovo\\IdeaProjects\\Insomnia\\src\\image\\1000582.png"));
                JPanel newRightOfHeader = new JPanel();
                newRightOfHeader.add(newCheckBox);
                newRightOfHeader.add(newDelete);
                JPanel new_center_header = new JPanel(new GridLayout(1, 2));
                new_center_header.add(newHeaderField);
                new_center_header.add(newValueField);
                JPanel newHeader = new JPanel(new BorderLayout());
                newHeader.add(newRightOfHeader, BorderLayout.EAST);
                newHeader.add(new_center_header, BorderLayout.CENTER);
                mainCenterHeader.add(newHeader);
            }
        }
    }
    // Exit app
    public class exitApp implements ActionListener
    {
        JCheckBox checkbox ;
        public exitApp(JCheckBox hideInSystemTray){
            checkbox = hideInSystemTray;
        }
        public void actionPerformed(ActionEvent e)
        {
            if (checkbox.isSelected() == true){
                TrayIcon trayIcon;
                SystemTray tray;
                    if(SystemTray.isSupported()){
                        System.out.println("system tray supported");
                        tray=SystemTray.getSystemTray();

                        Image image=Toolkit.getDefaultToolkit().getImage("/media/faisal/DukeImg/Duke256.png");
                        ActionListener exitListener=new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                System.out.println("Exiting....");
                                System.exit(0);
                            }
                        };
                        PopupMenu popup=new PopupMenu();
                        MenuItem defaultItem=new MenuItem("Exit");
                        defaultItem.addActionListener(exitListener);
                        popup.add(defaultItem);
                        defaultItem=new MenuItem("Open");
                        defaultItem.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                setVisible(true);
                                frame.setExtendedState(NORMAL);
                            }
                        });
                        popup.add(defaultItem);
                        trayIcon=new TrayIcon(image, "SystemTray Demo", popup);
                        trayIcon.setImageAutoSize(true);
                    }else{
                        System.out.println("system tray not supported");
                    }
                    setVisible(true);
            }
            else
            System.exit(0);
        }
    }
}
